/**
 * Copyright (c) 2008-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.jaas;

import java.security.GeneralSecurityException;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.security.auth.Subject;
import javax.security.auth.login.LoginContext;

/**
 * 
 * 
 * @author Christophe HAMERLING - eBM WebSourcing
 * @since 2.2
 * 
 */
public class JAASAuthenticationService implements AuthenticationService {

    private static final Logger logger = Logger
            .getLogger(JAASAuthenticationService.class.getName());

    /**
     * Creates a new instance of JAASAuthenticationService
     */
    public JAASAuthenticationService() {
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.ow2.petals.jbi.security.auth.AuthenticationService#authenticate(javax.security.auth.Subject,
     *      java.lang.String, java.lang.String, java.lang.Object)
     */
    public LoginContext authenticate(Subject subject, String domain, final String user,
            final Object credentials) throws GeneralSecurityException {
        if (logger.isLoggable(Level.INFO)) {
            logger.info("Authenticate user '" + user + "' with credentials '"
                    + credentials.toString() + "'...");
        }

        LoginContext loginContext = new LoginContext(domain, subject,
                new JAASCredentialCallbackHandler(user, credentials.toString()));
        loginContext.login();

        return loginContext;
    }
}
