/**
 * Copyright (c) 2008-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.jaas;

import junit.framework.TestCase;

/**
 * 
 * Created on 21 mars 2008
 * 
 * @author Christophe HAMERLING - eBM WebSourcing
 * @since
 * 
 */
public class GroupPrincipalTest extends TestCase {

    /**
     * @param name
     */
    public GroupPrincipalTest(String name) {
        super(name);
    }

    /* (non-Javadoc)
     * @see junit.framework.TestCase#setUp()
     */
    protected void setUp() throws Exception {
        super.setUp();
    }
    
    public void testEqualsObject() {
        GroupPrincipal gp1 = new GroupPrincipal("groupA");
        GroupPrincipal gp2 = new GroupPrincipal("groupA");
        GroupPrincipal gp3 = new GroupPrincipal("groupB");
        assertTrue(gp1.equals(gp2));
        assertFalse(gp1.equals(gp3));
        assertFalse(gp2.equals(gp3));
    }
    
    public void testAllGroupEquals() {
        GroupPrincipal gp1 = new GroupPrincipal("groupA");
        GroupPrincipal gp2 = new GroupPrincipal("*");
        GroupPrincipal gp3 = GroupPrincipal.ALL;
        assertFalse(gp1.equals(gp2));
        assertTrue(gp2.equals(gp3));
    }
}
